
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;

public class MyButton {

	int x0=0, y0=0, widthOfWidget=10, heightOfWidget=10;
	String label = "";
	private static final int margin = 2; // in pixels

	boolean isPressed = false;

	private Font font = null;
	private FontMetrics fontMetrics = null;

	public MyButton( int x0, int y0, int width, int height, String label ) {
		this.x0 = x0;
		this.y0 = y0;
		this.widthOfWidget = width;
		this.heightOfWidget = height;
		this.label = label;
	}

	public boolean isMouseOverWidget( int x, int y ) {
		return
			x0 <= x
			&& x < x0 + widthOfWidget
			&& y0 <= y
			&& y < y0 + heightOfWidget;
	}

	public void pressEvent( int x, int y ) {
		if ( isMouseOverWidget( x, y ) ) {
			isPressed = true;
		}
	}
	public void releaseEvent( int x, int y ) {
		if ( isPressed ) {
			isPressed = false;
		}
	}
	public void draw( Graphics2D g ) {
		// draw background
		g.setColor( isPressed ? Color.black : Color.white );
		g.fillRect( x0, y0, widthOfWidget, heightOfWidget );

		// draw border
		g.setColor( Color.black );
		g.drawRect( x0, y0, widthOfWidget-1, heightOfWidget-1 );

		// draw string
		int fontHeight = heightOfWidget/2;
		if ( font == null ) {
			font = new Font( "Sans-serif", Font.BOLD, fontHeight );
			fontMetrics = g.getFontMetrics( font );
		}
		int stringWidth = fontMetrics.stringWidth( label );
		g.setColor( isPressed ? Color.white : Color.black );
		g.setFont( font );
		g.drawString( label, x0+(widthOfWidget-stringWidth)/2, y0+heightOfWidget/2+fontHeight/2 );

	}
}

